// $Id: testauto.java,v 1.1 1997/11/19 18:20:36 xzhu Exp $
// testauto.java
//
// Author: Xiaokun Kelvin ZHU
// Address: kelvinxz@iname.com
// 1997/09/14
//
package test;

import java.sql.*;
import zxk.util.*;

public class testauto implements DBugConstant
{
  private testauto()
  {
  }

  public void doit(String[] args)
  {
    String debugStr = null;
    String url = new String("jdbc:mysql://localhost:3306/test?user=xzhu;password=");
    
    if (debugStr == null)
      debugStr = new String("");
    if (zxk_debug)
      DBug.dbug.dbPush(debugStr);
    
    Connection conn;
    int updateRows;
    try
    {
      //
      // Connect and start timing
      //
      Class.forName ("gwe.sql.gweMysqlDriver");
      conn = DriverManager.getConnection(url);
      //
      // Create needed tables
      //
      Statement stmt = conn.createStatement();
	try 
	{ stmt.executeUpdate("drop table autotest");
	} catch (SQLException e2) {}
        stmt.executeUpdate("create table autotest (id int AUTO_INCREMENT PRIMARY KEY, name char(32))");
        updateRows = stmt.executeUpdate("insert into autotest values (null, 'xzhu')");
	SQLWarning warn = stmt.getWarnings();
	if (warn != null)
	{
	  String s1 = warn.getMessage();
	  int j = s1.indexOf("Command=query: ");
          if (j > -1)
	  {
	    j = new Integer(s1.substring("Command=query: ".length())).intValue();
	    System.out.println("Update rows: " + updateRows + "  Auto_increased ID: " + j);
	  }
	}
        stmt.executeUpdate("insert into autotest values (null, 'kelvin')");
        while (true)  
	{
          updateRows = stmt.getUpdateCount(); 
          if (updateRows >= 0)     //  this is an update count
	  {
            System.out.println("Rows changed = " + updateRows);
            stmt.getMoreResults();
	    if (updateRows > 0)
	    {
              int updateID = stmt.getUpdateCount(); 
	      if (updateID > 0)
	      {
                System.out.println("Auto-increased ID = " + updateID);
                stmt.getMoreResults();
	      }
	    }
            continue;
          }
          // if we have gotten this far, we have either a result set
          // or no more results
          ResultSet rs = stmt.getResultSet();
          if (rs != null) 
	  {
            displayResult(rs);
            continue;
          } 
          break;      // there are no more results
        }	
      // It's really a small table, so we can try a select on everything
      ResultSet rs = stmt.executeQuery("select * from autotest");
      displayResult(rs);
      conn.close();
    }
    catch (SQLException e)
    {
      System.err.println(e.getMessage());
      e.printStackTrace();
      System.exit(1);
    }
    catch (Exception e)
    {
      System.err.println(e.getMessage());
      e.printStackTrace();
      System.exit(1);
    }
  }

  private int displayResult(ResultSet rs)
    throws SQLException
  {               
    int i;          
    int rows = 0;
    ResultSetMetaData rsmd = rs.getMetaData ();
    int numCols = rsmd.getColumnCount ();
        
    try 
    {
    boolean hasMore = rs.next();
    if (hasMore)
    {
      // Display column headings
      System.out.print("|");
      for (i=1; i<=numCols; i++) 
      {
        System.out.print(rsmd.getColumnName(i));
        System.out.print("\t|");
      }
      System.out.println("");
      // Display data, fetching until end of the result set
      while (hasMore) 
      {          
        rows++;    
        System.out.print("|");
        for (i=1; i<=numCols; i++) 
        {
          System.out.print(rs.getString(i));
  	System.out.print("\t|");
        }
        System.out.println("");
	hasMore = rs.next();
      }
    }       
    } 
    catch (SQLException e)
    { throw e; }

    return rows;
  }       

  public static void main (String[] args) 
  {
    testauto admin = new testauto();
    admin.doit(args);
  }
}
